//console.log("executing code in contentScript.js");
chrome.runtime.sendMessage({"message": "activate_icon"});


///experiment with sidebar
let cbInsightsExtension;
let cbInsightsWrapper;
window.addEventListener('DOMContentLoaded', (event) => {
    console.log('DOM fully loaded and parsed');

    cbInsightsWrapper = document.createElement('div'); 
    cbInsightsWrapper.style.position = "fixed";
    cbInsightsWrapper.style.width="136px";
    cbInsightsWrapper.style.height = "36px";
    if(useBottomDrawer) {
        cbInsightsWrapper.style.bottom = "0px";
    }
    else {
        cbInsightsWrapper.style.top = "0px";
    }
    cbInsightsWrapper.style.right = "0px";
    cbInsightsWrapper.style.zIndex = "90000000";
    
    cbInsightsExtension = document.createElement('iframe'); 
    cbInsightsExtension.style.background = "";
    cbInsightsExtension.style.width = "100%";
    cbInsightsExtension.style.background = ""; //transparent
    cbInsightsExtension.style.height = "36px";
    cbInsightsExtension.frameBorder = "none"; 
    cbInsightsExtension.id = "cbcaminsights-extension";
    cbInsightsExtension.src = chrome.runtime.getURL("cbcaminsights-extension/build/index.html")

    document.body.appendChild(cbInsightsWrapper);
    cbInsightsWrapper.appendChild(cbInsightsExtension);

    //console.log("added wrapper", cbInsightsWrapper);
});
function toggleSidebar() {
    if(cbInsightsExtension.style.background == ""){
        cbInsightsExtension.style.background = "white";
        cbInsightsExtension.style.height = "100vh";
        cbInsightsWrapper.style.width = "350px";
        cbInsightsWrapper.style.height = "100vh";
        cbInsightsWrapper.style.boxShadow = "rgba(0, 0, 0, 0.64) 0px 10px 20px";
    }
    else {
        cbInsightsWrapper.style.boxShadow = "";
        cbInsightsExtension.style.background = ""; //transparent
        cbInsightsExtension.style.height = "36px";
        cbInsightsWrapper.style.width="137px";
        cbInsightsWrapper.style.height = "36px";
    }
}

var s = document.createElement('script');
s.src = chrome.runtime.getURL('script.js');
(document.head||document.documentElement).appendChild(s);
s.onload = function() {
    //console.log("loaded script.js");
    s.parentNode.removeChild(s);
};


let eventQueue = [];
let rawEventsQueue = [];
let tips = 0;
let lastTipTime;
let lastCbDataFetchTime;
let performerName = '';
let uploadEnabled = false;
let uploadRawDataEnabled = false;
let chatExtensionsEnabled = false;
let apiKey = '';
let highestTip = {};
let hashtags = {};
let tippers = {};
let tids = {};
let interactions = [];
let bestTippers = [];
let followersStart;
let followerGains;
let allStarTipperMap;
let scriptLoadTime = new Date();
let tipperTimeRangeDays = 99999;
let interactionsHoursRange = 10;
let useBottomDrawer = false;

chrome.storage.local.get('followers', function(data) {
    followersStart = data.followers?.followersStart;
    //console.log("got followersStart from store", followersStart);
});

chrome.storage.local.get('tids', function(data) {
    tids = data.tids || tids;
    //console.log("got tippers from store", data, tippers);
});

chrome.storage.local.get('allTippers', function(data) {
    tippers = data.allTippers || tippers;
    //console.log("got tippers from store", data, tippers);
});


chrome.storage.local.get('interactions', function(data) {
    interactions = data.interactions || interactions;
    //console.log("got interactions from store", data, interactions);
});

chrome.storage.local.get('tips', function(data) {
    var twoHoursBefore = new Date();
    twoHoursBefore.setHours(twoHoursBefore.getHours() - 2);
    if(data.tips && data.tips.lastTipTime > twoHoursBefore) {
        tips = data.tips.amount;
        lastTipTime = data.lastTipTime;
    }
    else {
        lastTipTime =  new Date();
        tips = 0;
        chrome.storage.local.set({tips : {amount: tips, lastTipTime: lastTipTime }}, function() {});
    }
});


chrome.storage.local.get('cb_config', function(data) {

    if(data && data.cb_config) {
        performerName = data.cb_config.chaturbate_name?.toLowerCase();
        apiKey = data.cb_config.api_key;
        uploadEnabled = data.cb_config.upload;
        uploadRawDataEnabled = data.cb_config.uploadRaw;
        chatExtensionsEnabled =  data.cb_config.enableChatExtensions;
        tipperTimeRangeDays = data.cb_config.tipperTimeRange || 99999;
        interactionsHoursRange = data.cb_config.interactionsHoursRange || 0.5;
        useBottomDrawer = data.cb_config.useBottomDrawer;
        console.log("loaded performer", performerName, apiKey, uploadEnabled, chatExtensionsEnabled, tipperTimeRangeDays, interactionsHoursRange);

        if(cbInsightsWrapper) {
            if(useBottomDrawer) {
                //console.log("switched to bottom");
                cbInsightsWrapper.style.removeProperty("top");
                cbInsightsWrapper.style.bottom = "0px";
            }
            else {
                //console.log("switched to top");
                cbInsightsWrapper.style.removeProperty("bottom");
                cbInsightsWrapper.style.top = "0px";
            }
        }
    
    }
    
    if(chatExtensionsEnabled) {
        getCITipperChatInfo(performerName, apiKey, tipperTimeRangeDays, (tipperMap) => {
            //console.log("got tipper map", tipperMap);
            allStarTipperMap = tipperMap;
            extendUserList(tipperMap);
        });
    }
});
let lastEventTime = new Date();
let chatVideoContextFetched;
let currentRoomStatus;
let currentPrivateShowInfo;

const fetchUploadUrl = "https://api.cbcaminsights.com/user-event-upload";
const fetchRawUploadUrl = "https://api.cbcaminsights.com/user-raw-event-upload";
const fetchUserInfoUrl =  (timeRangeDays) => `https://api.cbcaminsights.com/user-tipper-all?days=${timeRangeDays}`;

const getBioContextUrl = (performerName) => `https://chaturbate.com/api/biocontext/${performerName}/`;
const getChatVideoContextUrl = (performerName) => `https://chaturbate.com/api/chatvideocontext/${performerName}/`;
const getchatUserListUrl = (performerName) => `https://chaturbate.com/api/getchatuserlist/?roomname=${performerName}`;

chrome.runtime.onMessage.addListener(
    function(message, sender, sendResponse) {
        //console.log("got update message", message);

        if(message === "toggle_sidebar"){
            toggleSidebar();
        }
        if (message.cb_config) {
            performerName = message.cb_config.chaturbate_name?.toLowerCase();
            apiKey = message.cb_config.api_key;
            uploadEnabled = message.cb_config.upload;
            uploadRawDataEnabled = message.cb_config.uploadRaw;

            if(!chatExtensionsEnabled && message.cb_config.enableChatExtensions || (message.cb_config.enableChatExtensions && tipperTimeRangeDays !=message.cb_config.tipperTimeRange)) {
                getCITipperChatInfo(performerName, apiKey, message.cb_config.tipperTimeRange, (tipperMap) => {
                    //console.log("got tipper map", tipperMap);
                    allStarTipperMap = tipperMap;
                    extendUserList(tipperMap);
                });
                //return true;
            }
            chatExtensionsEnabled = message.cb_config.enableChatExtensions;
            tipperTimeRangeDays = message.cb_config.tipperTimeRange;
            useBottomDrawer = message.cb_config.useBottomDrawer;
            interactionsHoursRange = message.cb_config.interactionsHoursRange || 0.5;
            if(cbInsightsWrapper) {
                if(useBottomDrawer) {
                    //console.log("switched to bottom");
                    cbInsightsWrapper.style.removeProperty("top");
                    cbInsightsWrapper.style.bottom = "0px";
                }
                else {
                    //console.log("switched to top");
                    cbInsightsWrapper.style.top = "0px";
                    cbInsightsWrapper.style.removeProperty("bottom");
                }
            }
            console.log("updated performer", performerName, apiKey, uploadEnabled, chatExtensionsEnabled, tipperTimeRangeDays, interactionsHoursRange, uploadRawDataEnabled);
        }
        else if (message.allTippers) {
            //a reset was triggered
            tippers = {};
            tids = {};
            hashtags = {};
            interactions = [];
            followersStart = undefined;
            lastCbDataFetchTime = undefined;
        }
    });

function getCITipperChatInfo(performerName, apiKey, days, callback) {
    let body = JSON.stringify({
        performerName : performerName,
        apiKey : apiKey
    });
    fetch(fetchUserInfoUrl(days), 
        {
            method:"POST",
            headers: {
                'Accept-Encoding': 'gzip',
                'x-api-key' : 'WF68zWbfcy3z0cMfFnI3y6VMThjtZRGt511spHXv',
            },
            mode: 'cors',
            body: body
        })
        .then(results => {
           return results.json();
        })
        .then(tipperInfo => {
            let tipperMap = {};
            for(let i=0;i < tipperInfo.length;i++) {
                tipperMap[tipperInfo[i].name] = tipperInfo[i];
            }
            callback(tipperMap);
        })
        .catch(err => {
            console.log(err);
        })    
}

function uploadRawEvents(rawEvents) {
    //console.log("uploadRawEvents", rawEvents);
    let body = JSON.stringify(rawEvents);
    fetch(fetchRawUploadUrl, 
        {
            method:"POST",
            headers: {
                'Accept-Encoding': 'gzip',
                'x-api-key' : 'WF68zWbfcy3z0cMfFnI3y6VMThjtZRGt511spHXv',
            },
            mode: 'cors',
            body: body
        })
        .then(results => {
           return results.json();
        })
        .then(jsonResult => {
            console.log("POST result", jsonResult);
        })
        .catch(err => {
            console.log(err);
        })        
}

function uploadEvents(performerEvents) {
    let body = JSON.stringify(performerEvents);
    fetch(fetchUploadUrl, 
        {
            method:"POST",
            headers: {
                'Accept-Encoding': 'gzip',
                'x-api-key' : 'WF68zWbfcy3z0cMfFnI3y6VMThjtZRGt511spHXv',
            },
            mode: 'cors',
            body: body
        })
        .then(results => {
           return results.json();
        })
        .then(jsonResult => {
            console.log("POST result", jsonResult);
        })
        .catch(err => {
            console.log(err);
        })        
}

function fetchJsonData(url, callback) {
    console.log("API fetch for " + url);
    fetch(url, 
        {
            method:"GET",
            headers: {
                'Accept-Encoding': 'gzip',
            }
        })
        .then(results => {
           return results.json();
        })
        .then(jsonResult => {
            callback(jsonResult); 
        })
        .catch(err => {
            console.log(err);
        })        
}

function fetchChatUserList(url, callback) {
    console.log("API fetch for " + url);
    fetch(url, 
        {
            method:"GET",
            headers: {
                'Accept-Encoding': 'gzip',
            }
        })
        .then(results => {
           return results.text();
        })
        .then(textResult => {
            //process
            let entries = CSVToArray(textResult, ",")[0];
            let anonCount = parseInt(entries[0], 10);
            //console.log("anonCount", anonCount);
            let viewers = entries.slice(1);
            let viewerTypes = viewers.map(x =>  x.split("|")[1]);
            let viewerToType = viewers.map(x =>  x.split("|"));
            let viewerToTypeMap = {};
            for(let i=0;i<viewerToType.length;i++) {
                let entry = viewerToType[i];

                if(entry[1] === "g") {continue;}

                viewerToTypeMap[entry[0]] = entry[1];
            }

            let viewerMap = {};
            for(let i=0;i<viewerTypes.length;i++) {
                if(!viewerMap[viewerTypes[i]]) viewerMap[viewerTypes[i]] = 0;
                viewerMap[viewerTypes[i]]++;
            }
            viewerMap['anon'] = anonCount;

            //also send the full list of users with their status
            //const audience = Object.entries(viewerMap);
            //console.log("entries", audience);
            callback(viewerMap, viewerToTypeMap); 
        })
        .catch(err => {
            console.log(err);
        })       
}

function CSVToArray( strData, strDelimiter ){
    // Check to see if the delimiter is defined. If not,
    // then default to comma.
    strDelimiter = (strDelimiter || ",");

    // Create a regular expression to parse the CSV values.
    var objPattern = new RegExp(
        (
            // Delimiters.
            "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +

            // Quoted fields.
            "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +

            // Standard fields.
            "([^\"\\" + strDelimiter + "\\r\\n]*))"
        ),
        "gi"
        );


    // Create an array to hold our data. Give the array
    // a default empty first row.
    var arrData = [[]];

    // Create an array to hold our individual pattern
    // matching groups.
    var arrMatches = null;


    // Keep looping over the regular expression matches
    // until we can no longer find a match.
    while (arrMatches = objPattern.exec( strData )){

        // Get the delimiter that was found.
        var strMatchedDelimiter = arrMatches[ 1 ];

        // Check to see if the given delimiter has a length
        // (is not the start of string) and if it matches
        // field delimiter. If id does not, then we know
        // that this delimiter is a row delimiter.
        if (
            strMatchedDelimiter.length &&
            strMatchedDelimiter !== strDelimiter
            ){

            // Since we have reached a new row of data,
            // add an empty row to our data array.
            arrData.push( [] );

        }

        var strMatchedValue;

        // Now that we have our delimiter out of the way,
        // let's check to see which kind of value we
        // captured (quoted or unquoted).
        if (arrMatches[ 2 ]){

            // We found a quoted value. When we capture
            // this value, unescape any double quotes.
            strMatchedValue = arrMatches[ 2 ].replace(
                new RegExp( "\"\"", "g" ),
                "\""
                );

        } else {

            // We found a non-quoted value.
            strMatchedValue = arrMatches[ 3 ];

        }


        // Now that we have our value string, let's add
        // it to the data array.
        arrData[ arrData.length - 1 ].push( strMatchedValue );
    }

    // Return the parsed data.
    return( arrData );
}

function handleUserRefreshClicked() {
    getCITipperChatInfo(performerName, apiKey, tipperTimeRangeDays, (tipperMap) => {
        //console.log("refreshed getCITipperInfo");
        allStarTipperMap = tipperMap;
        extendUserList(tipperMap);
        });
}

function hookupUserRefresh() {
    let refreshLink = document.getElementsByClassName("refreshUsersLink")[0];
    if(refreshLink) {
        //console.log("found refreshLink", refreshLink);
        refreshLink.removeEventListener("click", handleUserRefreshClicked, false);
        refreshLink.addEventListener("click", handleUserRefreshClicked, false); 
    }
}

/*
function syncUserNotes() {
    let userNotes = document.getElementsByClassName("userNoteText")[0];
}
*/

function handleUserTabClicked() {
    //extendUserList(allStarTipperMap);
    setTimeout(() => extendUserList(allStarTipperMap), 1000);
}

function handleTipperNameClicked(e) {
    //console.log("got tipper click event!", e.target.innerText);
    let text = e.target.innerText;
    if(text.includes('📹')) {
        text = text.split('📹')[0];
    }
    //console.log("extracted tipper name", text);
    
    //todo: is the right element content selected already?
    chrome.runtime.sendMessage({"tipper_selected": text});
}

function extendUserList(tipperMap) {

    if(!chatExtensionsEnabled) {return;}
    let userTab = document.querySelector("#users-tab-default");
   
    if(userTab) {
        //console.log("found userTab");
        userTab.removeEventListener("click", handleUserTabClicked, false);
        userTab.addEventListener("click", handleUserTabClicked, false); 
    }
    
    let userListTab = document.querySelector("#UserListTab  div");
    if(!userListTab || userListTab.innerText === 'Loading user list...') {
        setTimeout(() => extendUserList(tipperMap), 2000);
        return;
    }

    let userListItems = document.querySelectorAll("#UserListTab div[ts]");
    let userTipInfo = document.querySelectorAll("#UserListTab div[tip_info]");

    //console.log("got tip info", userTipInfo);
    for(let i=0;i < userTipInfo.length;i++) {
        userTipInfo[i].parentNode.removeChild(userTipInfo[i]);
    }

    hookupUserRefresh();

    //console.log("extending user list", userListItems);

    for(let i=0;i < userListItems.length;i++) {
        let item = userListItems[i];

        //attach onclick listener if not present already
        item.removeEventListener("click", handleTipperNameClicked, false);
        item.addEventListener("click", handleTipperNameClicked, false); 

         let txt = item.innerText;
         item.getch
        //if(txt.indexOf('📹') > 0 || txt.length === 0) { break; }
        if(txt.length === 0) { break; }
        //console.log("looking at " + item.innerText, userListItems[i]);
        if(txt && tipperMap[txt]) {
            //console.log("found match for " + item.innerText);
            let div = document.createElement("div");
            div.setAttribute('style', "margin-left: 7px;display:inline;color:#cc9808;font-weight:normal");
            div.setAttribute('tip_info', 'true');
            let session_count = tipperMap[item.innerText].session_count;
            if(session_count === 0) { session_count=1; }
            let sessionSingularOrPlural = session_count === 1 ? 'session' : 'sessions';

            //should I make this a clickable div?
            let t = document.createTextNode("📹 "  + session_count + " " + sessionSingularOrPlural + " / 💸 " + tipperMap[item.innerText].amount.toLocaleString() + " tokens" );
            div.appendChild(t);
            item.appendChild(div);
        }
    }
}

function updateBasicEvents(jsonEvent) {
    let eventTime = new Date();
    let timeBetweenUpdates = new Date();
    timeBetweenUpdates.setSeconds(timeBetweenUpdates.getSeconds() - 120);
    if(!lastCbDataFetchTime || lastCbDataFetchTime < timeBetweenUpdates){
        lastCbDataFetchTime = eventTime;

        fetchChatUserList(getchatUserListUrl(performerName), (chatAudience, fullAudience) => {
            let cbAudienceUpdateEvent = {
                args: chatAudience,
                method: 'basicChatAudienceUpdate',
                time: eventTime,
            };

            chrome.runtime.sendMessage({"audience_update": cbAudienceUpdateEvent});
        });

        fetchJsonData(getBioContextUrl(performerName), (bioContext) => {
            //console.log("got biocontext", new Date(), bioContext);
            if(!followersStart) { followersStart = bioContext.follower_count}
            else { 
                followerGains = bioContext.follower_count - followersStart;
                chrome.storage.local.set({followers : {followersStart: followersStart, followerGains: followerGains} }, function() {});
            }
        });
    }

    chrome.runtime.sendMessage({"room_event": jsonEvent});
}

function getEventMethod(eventArgs) {

    let topic =  eventArgs._topic

    if(topic === 'UserTipAlertTopic' || topic === 'RoomTipAlertTopic') { 
        //apparently there's both user:tip_alert and room:tip_alert 
        //the user: channel I assume is just for the broadcaster, that's why I can't see it
        return "tip_alert";
    }
    if(topic === 'RoomPurchaseTopic') {
        return "purchase";
    }
    if(topic === 'RoomMessageTopic') {
        return "message";
    }
    if(topic === 'RoomEnterLeaveTopic' || topic == 'RoomPrivilegedLeaveTopic') {
        return "enter_leave";
    }
    if(topic === 'RoomPrivilegedEnterTopic') {
        return "privileged_enter";
    }
    if(topic === 'RoomNoticeTopic') {
        return "notice";
    }
    if(topic === 'UserFollowerTopic') {
        //we can track followers directly now!
        //console.log("got new follower!!");
    }
    
    return undefined;
}

function prepareAndUploadRawData(rawEvent) {

    //console.log("adding to raw event queue", rawEvent);
    let eventTime = new Date();
    let cbMessageWrapper = {
        args: rawEvent,
        time: eventTime.toISOString(),
    };
    rawEventsQueue.push(cbMessageWrapper);

    //upload if needed
    if(rawEventsQueue.length > 0) {
        var minutesInQueue = (eventTime - new Date(rawEventsQueue[0].time)) /  60000;
        if(minutesInQueue >= 2) {
            //flush queue
            //console.log("flushing event queue, time since last flush", minutesInQueue);
            let rawEventsToSend = rawEventsQueue.slice();
            rawEventsQueue = [];
            let rawEventsBatch = {
                events: rawEventsToSend,
                performerName: performerName,
                apiKey: apiKey,
                clientVersion: "1.4.2"
            }

            //To TEST comment this out!
            uploadRawEvents(rawEventsBatch);
        }
    }

}

function prepareAndUploadEvents(jsonEvent) {
    //console.log("in prepareAndUploadEvents", jsonEvent);


    let eventTime = new Date();

    //also check if we need to update follower count
    let timeBetweenUpdates = new Date();
    timeBetweenUpdates.setSeconds(timeBetweenUpdates.getSeconds() - 150);
    if(!lastCbDataFetchTime || lastCbDataFetchTime < timeBetweenUpdates){
        lastCbDataFetchTime = eventTime;
        
        fetchJsonData(getBioContextUrl(performerName), (bioContext) => {
            //console.log("got biocontext", new Date(), bioContext);
            if(!followersStart) { followersStart = bioContext.follower_count}
            else { 
                followerGains = bioContext.follower_count - followersStart;
                chrome.storage.local.set({followers : {followersStart: followersStart, followerGains: followerGains} }, function() {});
            }
            let bioContextEventArgs = {
                follower_count : bioContext.follower_count,
                fan_club_cost: bioContext.fan_club_cost,
                room_status: bioContext.room_status,
            }

            let cbDataUpateEvent = {
                args: bioContextEventArgs,
                method: 'onBioContextUpdate',
                time: eventTime.toISOString(),
            };
            eventQueue.push(cbDataUpateEvent);


            let newRoomStatus = bioContextEventArgs.room_status.toLowerCase();
            if(newRoomStatus === 'private') {
                if(newRoomStatus != currentRoomStatus) {
                    //refetch!
                    currentRoomStatus = newRoomStatus;
                    //we just went into private --> refetch private charge data
                    fetchJsonData(getChatVideoContextUrl(performerName), (chatVideoContext) => {
                        //console.log("got chat video context after bio", chatVideoContext);
                        currentPrivateShowInfo = {
                            private_show_price : chatVideoContext.private_show_price,
                            spy_private_show_price: chatVideoContext.spy_private_show_price,
                            private_min_minutes: chatVideoContext.private_min_minutes,
                            room_status: chatVideoContext.room_status,
                        }

                        let cbPrivateShowInfoEvent = {
                            args: currentPrivateShowInfo,
                            method: 'onPrivateShowPriceInfo',
                            time: eventTime.toISOString(),
                        };
                        //console.log("got video context event", cbPrivateShowInfoEvent);
        
                        eventQueue.push(cbPrivateShowInfoEvent);
                    });
                }
                else {
                    //send stored private charge data event
                    currentPrivateShowInfo.cached = true;
                    currentPrivateShowInfo.room_status = newRoomStatus;
                    if(currentPrivateShowInfo) {
                        let cbPrivateShowInfoEvent = {
                            args: currentPrivateShowInfo,
                            method: 'onPrivateShowPriceInfo',
                            time: eventTime.toISOString(),
                        };
                        //console.log("got video context event", cbPrivateShowInfoEvent);
                        eventQueue.push(cbPrivateShowInfoEvent);
                    }
                }
            }
        });

        fetchChatUserList(getchatUserListUrl(performerName), (chatAudience, fullAudience) => {
            let cbAudienceUpdateEvent = {
                args: chatAudience,
                method: 'onChatAudienceUpdate',
                time: eventTime.toISOString(),
            };

            let cbFullAudienceFullListEvent = {
                args: fullAudience,
                method: 'onChatAudienceFullList',
                time: cbAudienceUpdateEvent.time,
            }

            eventQueue.push(cbAudienceUpdateEvent);
            eventQueue.push(cbFullAudienceFullListEvent);

            let cbAudienceUpdateEventLive = {
                args: chatAudience,
                method: 'onChatAudienceUpdate',
                time: eventTime,
            };


            chrome.runtime.sendMessage({"audience_update": cbAudienceUpdateEventLive});
        });

        if(!chatVideoContextFetched) {
            chatVideoContextFetched = true;
            fetchJsonData(getChatVideoContextUrl(performerName), (chatVideoContext) => {
                //console.log("got chat video context", chatVideoContext);
                currentPrivateShowInfo = {
                    private_show_price : chatVideoContext.private_show_price,
                    spy_private_show_price: chatVideoContext.spy_private_show_price,
                    private_min_minutes: chatVideoContext.private_min_minutes,
                    room_status: chatVideoContext.room_status,
                }

                let cbPrivateShowInfoEvent = {
                    args: currentPrivateShowInfo,
                    method: 'onPrivateShowPriceInfo',
                    time: eventTime.toISOString(),
                };
                //console.log("got video context event", cbPrivateShowInfoEvent);

                eventQueue.push(cbPrivateShowInfoEvent);
            });
        }
    }

    if(jsonEvent.method && jsonEvent.args) {
        let uploadEvent = {
            args: jsonEvent.args,
            method: jsonEvent.method,
            time: eventTime.toISOString(),
        };
        eventQueue.push(uploadEvent);

        //console.log("uploadEvent", uploadEvent);
        lastEventTime = eventTime;
    }
    //upload if needed
    if(eventQueue.length > 0) {
        var minutesInQueue = (eventTime - new Date(eventQueue[0].time)) /  60000;
        if(minutesInQueue >= 3) {
            //flush queue
            //console.log("flushing event queue, time since last flush", minutesInQueue);
            let eventsToSend = eventQueue.slice();
            eventQueue = [];
            let eventBatch = {
                events: eventsToSend,
                performerName: performerName,
                apiKey: apiKey,
                clientVersion: "1.4.2"
            }

            //console.log("sending batch", eventBatch);
            //To TEST comment this out!
            uploadEvents(eventBatch);
        }
    }
    chrome.runtime.sendMessage({"room_event": jsonEvent});
}

window.addEventListener("message", function(event) {
  // We only accept messages from ourselves
  if (event.source != window)
    return;

  if (event.data.type && (event.data.type == "CB_LISTENER_SOCKET_MESSAGE")) {

    //console.log("Content script received: " + event.data.text);

    const socketMessage = JSON.parse(event.data.text);
    //console.log("got message", socketMessage);

    //make sure that this is actually frome the configured performer
    let url = event.data.url.toLowerCase();
    //ignore title for now, rely on URL
    if(!performerName || url.indexOf(`/${performerName}/`) < 0) {
        //nothing to do here
        //console.log(`unknown performer - looking for ${performerName}, ignoring`, url);
        return;
    }

    if(uploadRawDataEnabled) {
        try { 
            prepareAndUploadRawData(socketMessage);
        } catch (error) {
            console.error(error);
        }
    }    

    if(socketMessage.action) {
        lastEventTime = new Date();

        //ignore everything in the first couple seconds, so that we don't count
        //tips twice from the preload
        let fourSecondsAgo = new Date();
        fourSecondsAgo.setSeconds(fourSecondsAgo.getSeconds() - 5);
        if(fourSecondsAgo < scriptLoadTime) {
            console.log("IGNORING message in first 4 seconds");
            return;
        }

        //let messagePart = event.data.text.substr(1);
        //console.log(jsonEvent)
        //console.log("got event", socketMessage);
        let jsonEvent = {};
        let hasData = socketMessage.messages && socketMessage.messages.length > 0;
        if(hasData) {
            //console.log("got event of type", eventType, socketMessage.messages[0].data);
            let eventData = socketMessage.messages[0].data;
            if(eventData && eventData[0] == '{') {eventData = JSON.parse(eventData); }
            jsonEvent = {
                method: getEventMethod(eventData),
                args: eventData
            }
        }

        switch(jsonEvent.method) {
            case undefined: 
                //console.log("Unknown message");
                break;
            case 'enter_leave':
                //console.log('got enter_leave message', jsonEvent.args);
                break;
            case 'notice': 
            {
                if(uploadEnabled) {
                    //console.log("uploading", jsonEvent);
                    prepareAndUploadEvents({});
                }
                break;
            }
            case 'message':
            {
                //console.log('Oranges are $0.59 a pound.');
                //break;
                //send up room messages for analytics
                //let messageData = socketMessage.messages[0].data;
                //console.log("got message message data", messageData);
                let message = jsonEvent.args;
                message.message = '';
                if(message.from_username === performerName) { break; } // don't count messages from the broadcaster
                //console.log("onRoomMsg full msg", jsonEvent, jsonEvent.args[0]);
                //blank out the message because it can be sensitive

                //this could get really large -> how do we reduce the size?
                //idea: use custom data structure with only the fields we need

                
                let interaction = {
                    time: lastEventTime.toISOString(),
                    user: message.from_user.username,
                    gender: message.from_user.gender,
                    is_mod: message.from_user.is_mod,
                    is_following: message.from_user.is_following,
                    in_fanclub: message.from_user.in_fanclub,
                    tipped_tons_recently: message.from_user.tipped_tons_recently,
                    tipped_alot_recently: message.from_user.tipped_alot_recently,
                    tipped_recently: message.from_user.tipped_recently,
                    has_tokens: message.from_user.has_tokens
                }
                //console.log("got interaction message", interaction);
                
                interactions.push(interaction);
                //limit time for interactions collection to 10 hours max
                let skipCount = 0;
                let cutoffTime = new Date();
                cutoffTime.setHours(cutoffTime.getHours() - interactionsHoursRange); 
                for(let i=0; i<interactions.length;i++) {
                    if(new Date(interactions[i].time) < cutoffTime) {
                        //console.log("got cutoff", interactions[i].time, cutoffTime);
                        skipCount++;
                    }
                    else { break;}
                }
                if(skipCount > 0) {
                    interactions = interactions.slice(skipCount);
                }
                chrome.storage.local.set({interactions : interactions}, function() {});

                /*
                if(uploadEnabled) {
                    //console.log("uploading", jsonEvent);
                    prepareAndUploadEvents(jsonEvent);
                }
                */
                break;
            }
            case 'privileged_enter': 
            {
                //console.log("got enter_leave data", messageData);
                let exploringHash = jsonEvent.args?.exploring_hash;
                if(exploringHash) {
                    if(!hashtags[exploringHash]) {hashtags[exploringHash] = 1}
                    else {
                        hashtags[exploringHash]++;
                    }
                    const topHashtags = Object.entries(hashtags).sort(([,a],[,b]) => b-a).slice(0,6);
                    chrome.storage.local.set({topHashtags : topHashtags}, function() {});
                }

                if(uploadEnabled) {
                    prepareAndUploadEvents(jsonEvent);
                }
                break;
            }
            case 'tip_alert':
            {
                //console.log("got tip message data", tipMessageData);
                let tipMessage = jsonEvent.args;
                //let args = JSON.parse(jsonEvent.args[0]);
                
                //console.log("got event notify type", args.type, args);

                tips+=tipMessage.amount;

                //blank out the message because it can be sensitive
                tipMessage.message = '';
                //jsonEvent.args[0] = JSON.stringify(args);

                if(tipMessage.tid && tids[tipMessage.tid]) {
                    //already received this tip, ignore
                    console.log(`Ignoring tip message from ${tipMessage.from_username} for ${tipMessage.amount} tokens -  tip already registered`);
                    break;
                }
                tids[tipMessage.tid] = true;

                if(!tippers[tipMessage.from_username]) {tippers[tipMessage.from_username]= tipMessage.amount}
                else {
                    tippers[tipMessage.from_username] +=tipMessage.amount;
                }
                //ASSERTION TEST
                /*
                let testSumTips = 0;
                let tipperArray = Object.entries(tippers);
                for(let i=0;i<tipperArray.length;i++) {
                    testSumTips+= tipperArray[i][1];
                    console.log(tipperArray[i]);
                }
                console.log(`TIP AUDIT: tips_total = ${tips} sum tips from tippers = ${testSumTips}`);
                */
                //update top tippers
                const topTippers = Object.entries(tippers).sort(([,a],[,b]) => b-a).slice(0,6);
                chrome.storage.local.set({topTippers : topTippers}, function() {});
                chrome.storage.local.set({allTippers : tippers}, function() {});
                chrome.storage.local.set({tids : tids}, function() {});
            }

            default:
                if(uploadEnabled) {
                        prepareAndUploadEvents(jsonEvent);
                }
                else {
                    //console.log("Not uploading - disabled");
                    updateBasicEvents(jsonEvent);
                }
        }
    }
    //port.postMessage(event.data.text);

  }
}, false);